﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using EZ_Builder.Config.Sub;

namespace SMTP_Client {

  public partial class FormConfig : Form {

    PluginV1 _cf = new PluginV1();
    
    public FormConfig() {

      InitializeComponent();
    }

    public void SetConfiguration(PluginV1 cf) {

      _cf = cf;

      tbFromName.Text = cf.STORAGE.GetKey(ConfigDictionary._FROM_NAME, string.Empty).ToString();
      tbPassword.Text = cf.STORAGE.GetKey(ConfigDictionary._PASSWORD, string.Empty).ToString();
      tbPort.Text = cf.STORAGE.GetKey(ConfigDictionary._SMTP_PORT, 25).ToString();
      tbFromEmail.Text = cf.STORAGE.GetKey(ConfigDictionary._FROM_EMAIL, string.Empty).ToString();
      tbServerAddress.Text = cf.STORAGE.GetKey(ConfigDictionary._SMTP_ADDRESS, tbServerAddress.Text).ToString();
      tbUsername.Text = cf.STORAGE.GetKey(ConfigDictionary._USERNAME, string.Empty).ToString();
      cbUseAuthentication.Checked = Convert.ToBoolean(cf.STORAGE.GetKey(ConfigDictionary._USE_AUTHENTICATION, false));
      cbUseSSL.Checked = Convert.ToBoolean(cf.STORAGE.GetKey(ConfigDictionary._USE_SSL, false));    
    }

    public PluginV1 GetConfiguration() {

      _cf.STORAGE.AddOrUpdate(ConfigDictionary._FROM_NAME, tbFromName.Text);
      _cf.STORAGE.AddOrUpdate(ConfigDictionary._FROM_EMAIL, tbFromEmail.Text);
      _cf.STORAGE.AddOrUpdate(ConfigDictionary._PASSWORD, tbPassword.Text);
      _cf.STORAGE.AddOrUpdate(ConfigDictionary._SMTP_ADDRESS, tbServerAddress.Text);
      _cf.STORAGE.AddOrUpdate(ConfigDictionary._SMTP_PORT, Convert.ToInt32(tbPort.Text));
      _cf.STORAGE.AddOrUpdate(ConfigDictionary._USE_AUTHENTICATION, cbUseAuthentication.Checked);
      _cf.STORAGE.AddOrUpdate(ConfigDictionary._USERNAME, tbUsername.Text);
      _cf.STORAGE.AddOrUpdate(ConfigDictionary._USE_SSL, cbUseSSL.Checked);

      return _cf;
    }

    private void button1_Click(object sender, EventArgs e) {

      try {

        if (tbServerAddress.Text == string.Empty)
          throw new Exception("SMTP Server Address must not be empty");

        if (tbFromName.Text == string.Empty)
          throw new Exception("From email address must not be empty");

        if (tbFromEmail.Text == string.Empty)
          throw new Exception("Reply-to email address must not be empty");

        if (cbUseAuthentication.Checked) {

          if (tbUsername.Text == string.Empty)
            throw new Exception("Username must not be empty if authentication is used");

          if (tbPassword.Text == string.Empty)
            throw new Exception("Password must not be empty if authentication is used");
        }

        if (!EZ_B.Functions.IsNumeric(tbPort.Text))
          throw new Exception("Port must be a numeric value");

        DialogResult = System.Windows.Forms.DialogResult.OK;
      } catch (Exception ex) {

        MessageBox.Show("Error: " + ex.Message);
      }
    }
  }
}
